<CFSETTING ENABLECFOUTPUTONLY="YES">
<!--- || BEGIN FUSEDOC ||
	
|| PROPERTIES ||
	Application: custom tag
	Module Name: cf_mail
	File Name: inc_mail_util.cfm
	Version: 1.0
	Author: Max Paperno <MPaperno@worldDesign.com>
	Copyright: 2003 World Design Group, Inc.
				http://www.worlddesign.com/
	
|| RESPONSIBILITIES ||
	Utility function(s) to support the cf_mail custom tag. This separate file was required because having a custom
	function inside a tag which is called >1 time on a page causes an error (even if the 2nd instance
	is just the closing tag -- d'oh!)

|| HISTORY ||
	05.28.03 : created
	mm.dd.yy : updated (by: )
	
|| ATTRIBUTES ||
	

|| USAGE ||
	<cfinclude template="mail_util.cfm">
	

|| RETURN CODES ||
	

|| END FUSEDOC || --->


<cfscript>

	// This function takes a comma-delimited list of email addresses which may include
	// real names as well as the actual address and returns a list of only the addresses.
	// Consider a possible list of recipients like this: 
	//     "Doe, John" <joeD@example.com>, "Smith, Frank" <frankS@example.com>
	// So we cannot just loop over the list as a csv  :-(
	function cleanAddrList(listToCheck) {
	
		// local vars
		var result = "";
		var inQuotes = 0;
		var emailDelims = "<>() ";
		var char = "";
		var chkEmail = "";
		var i = 0;
	
		// we need to use the caret to make a delimited list so remove any if they happen to be there
		// ( not the most elegant solution here ).  Also get rid of any spaces just in case.
		listTocheck = REReplace(listTocheck, "[\^|[[:space:]]]", "", "ALL");
		
		// make a new list ignoring escaped (in quotes) commas
		// loop over each character in the list (not each list element!)
		for (i=1; i LTE Len(listToCheck); i=i+1) {
			char = Mid(listToCheck, i, 1);
			// if current character is a quote the set quoted state
			if ( char IS '"' OR char IS "'" )
				inQuotes = IIf( NOT inQuotes, 1, 0 );
			// if we're not inside quotes and there's a comma, replace it with a ^
			if ( NOT inQuotes AND char IS "," )
				listToCheck = Insert("^", RemoveChars(listToCheck, i, 1), i-1);
		}
		
		// now loop over the new list and find the addresses
		for (i=1; i LTE ListLen(listToCheck, "^"); i=i+1) {
			chkEmail = ListGetAt(listToCheck, i, "^");
			if ( Find("@", chkEmail) )
				result = ListAppend( result, ListGetAt( chkEmail, ListContains(chkEmail, "@", emailDelims), emailDelims ) );
		}
		
		return result;
	}
	
	// Append header name and value as struct to header array (variables.aryHeadersStruct)
	function addHeader(hdrName, hdrValue) {
	
		var structTemp = StructNew();
		var replaceIdx = 0;
		var i = 0;
		
		// first a dupe check: loop over existing headers
		for (i=1; i LTE ArrayLen(variables.aryHeadersStruct); i=i+1) {
			// if we find a match on the value in the header name...
			if ( NOT CompareNoCase(variables.aryHeadersStruct[i].name, hdrName) ) {
				// ... then mark the spot
				replaceIdx = i;
				break;
			}
		}
		
		structTemp.name = hdrName;
		structTemp.value = hdrValue;
		if ( replaceIdx ) 
	 		variables.aryHeadersStruct[replaceIdx] = structTemp;
		else
	 		ArrayAppend(variables.aryHeadersStruct, structTemp);
		
	
	}

</cfscript>

<CFSETTING ENABLECFOUTPUTONLY="NO">