<CFSETTING ENABLECFOUTPUTONLY="YES">
<!--- || BEGIN FUSEDOC ||
	
|| PROPERTIES ||
	Application: custom tag
	Module Name: cf_mail
	File Name: mailparam.cfm
	Version: 1.0
	Author: Maxim Paperno <MPaperno@WorldDesign.com>
	Copyright: 2003 World Design Group, Inc.
				http://www.worldDesign.com/
	
|| RESPONSIBILITIES ||
	Drop-in replacement for CFMAILPARAM tag.  Child of cf_mail tag.

|| HISTORY ||
	05.28.03 : created
	mm.dd.yy : updated (by: )
	
|| ATTRIBUTES ||
	(all are strings in attributes scope unless specified otherwise; '+' means required;)
	
	cfmailparam-compatible attributes (see cfmailparam docs for descriptions):
		+> file (required if NAME isn't present)
		+> name (required if FILE isn't present)
		-> value

|| USAGE ||
	<cf_mail to="somewhere@example.com" from="someone@example.com" subject="Test Subject">
		<cf_mailparam name="X-Mailier" value="foobar">
		... message text ...
	</cf_mail>
	

|| RETURN CODES ||
	0-99:Success; 100-199:Warning; 200-299:Error
	
	0 : Default success result
	
	200 : Unknown error condition
	240 : Neither NAME nor FILE attributes were passed
	

|| END FUSEDOC || --->

<!--- ####   ATTRIBUTE DECLARATIONS   #### --->

<!--- attributes are all passed to the base tag --->
<cfassociate basetag="cf_mail" datacollection="mailparamAttribs">
	
<!--- optional attributes --->
<cfparam name="attributes.name" default="" type="string">
<cfparam name="attributes.value" default="" type="string">
<cfparam name="attributes.file" default="" type="string">

  <!--- determines if errors terminate execution (default) or fail "softly" --->
<cfparam name="attributes.throwError" default="1" type="boolean"> 

<cftry>

	<!--- error checking --->
	<cfif NOT Len(Trim(attributes.name)) AND NOT Len(Trim(attributes.file))>
		<cfthrow type="Application" 
			errorcode="240" 
			message="CF_MAILPARAM: You must specify either a NAME or a FILE attrbute">
	</cfif>
	<!--- end error check --->
	
	<cfset caller.cf_mailparam.statusCode = 0>
	<cfset caller.cf_mailparam.statusMessage = "CF_MAILPARAM: Parameter setting successful">
	
	<cfcatch type="Any">
		<cfif attributes.throwError>
			<!--- just rethrow the error --->
			<cfrethrow>
		 <cfelse>
		 	<!--- return the error in the result vars --->
			<cfset caller.cf_mailparam.statusCode = IIf( Len(cfcatch.errorCode), "cfcatch.errorCode", 200 )>
			<cfset caller.cf_mailparam.statusMessage = cfcatch.message & "<br>" & 
										IIf( Len(cfcatch.detail), "cfcatch.detail", DE("") )>
		</cfif>
	</cfcatch>

</cftry>


<CFSETTING ENABLECFOUTPUTONLY="NO">